



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>R 语言程序设计</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">R 语言程序设计</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 12:13:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>Data</h3>
<h3>The zip file containing the data can be downloaded here:</h3>
<ul><li><a href="https://d396qusza40orc.cloudfront.net/rprog%2Fdata%2Fspecdata.zip" rel="external nofollow noreferrer">specdata.zip</a> [2.4MB]</li></ul>
<h3>The zip file contains 332 comma-separated-value (CSV) files containing pollution monitoring data for fine particulate matter (PM) air pollution at 332 locations in the United States. Each file contains data from a single monitor and the ID number for each monitor is contained in the file name. For example, data for monitor 200 is contained in the file "200.csv". Each file contains three variables:</h3>
<ul><li>Date: the date of the observation in YYYY-MM-DD format (year-month-day)</li>
<li>sulfate: the level of sulfate PM in the air on that date (measured in micrograms per cubic meter)</li>
<li>nitrate: the level of nitrate PM in the air on that date (measured in micrograms per cubic meter)</li></ul>
<h3>For this programming assignment you will need to unzip this file and create the directory 'specdata'. Once you have unzipped the zip file, <strong>do not</strong> make any modifications to the files in the 'specdata' directory. In each file you'll notice that there are many days where either sulfate or nitrate (or both) are missing (coded as NA). This is common with air pollution monitoring data in the United States.</h3>
<h3>Part 1</h3>
<p>Write a function named 'pollutantmean' that calculates the mean of a pollutant (sulfate or nitrate) across a specified list of monitors. The function 'pollutantmean' takes three arguments: 'directory', 'pollutant', and 'id'. Given a vector monitor ID numbers, 'pollutantmean' reads that monitors' particulate matter data from the directory specified in the 'directory' argument and returns the mean of the pollutant across all of the monitors, ignoring any missing values coded as NA. A prototype of the function is as follows</p>
<pre class="prettyprint linenums">pollutantmean &lt;- function(directory, pollutant, id = 1:332) {<br />
        ## 'directory' is a character vector of length 1 indicating<br />
        ## the location of the CSV files

        ## 'pollutant' is a character vector of length 1 indicating<br />
        ## the name of the pollutant for which we will calculate the<br />
        ## mean; either "sulfate" or "nitrate".

        ## 'id' is an integer vector indicating the monitor ID numbers<br />
        ## to be used

        ## Return the mean of the pollutant across all monitors list<br />
        ## in the 'id' vector (ignoring NA values)<br />
        ## NOTE: Do not round the result!<br />
}</pre>
<p>You can see some <a href="https://d396qusza40orc.cloudfront.net/rprog%2Fdoc%2Fpollutantmean-demo.html" rel="external nofollow noreferrer">example output from this function</a>. The function that you write should be able to match this output. Please save your code to a file named <strong>pollutantmean.R</strong>.</p>
<div>
<pre class="prettyprint linenums">pollutantmean &lt;- function(directory, pollutant, id = 1:332){<br />
    tempsum &lt;- 0<br />
    templen &lt;- 0<br />
    for(i in id ){<br />
            fid &lt;- sprintf("%03d",i)<br />
            filename &lt;- paste(directory,"/",fid,".csv",sep="")<br />
            dat &lt;- read.csv(filename)<br />
            src &lt;- dat[pollutant]<br />
            src &lt;- na.omit(src)              # omit NA<br />
            tempsum &lt;- tempsum + sum(src)<br />
            templen &lt;- templen + dim(src)[1]<br />
    }<br />
    if(templen &gt;0 ){<br />
        pollutantmean &lt;- tempsum / templen<br />
    }<br />
    pollutantmean<br />
}
</pre>
</div>
<h3>Part 2</h3>
<p>Write a function that reads a directory full of files and reports the number of completely observed cases in each data file. The function should return a data frame where the first column is the name of the file and the second column is the number of complete cases. A prototype of this function follows</p>
<pre class="prettyprint linenums">complete &lt;- function(directory, id = 1:332) {<br />
        ## 'directory' is a character vector of length 1 indicating<br />
        ## the location of the CSV files

        ## 'id' is an integer vector indicating the monitor ID numbers<br />
        ## to be used

        ## Return a data frame of the form:<br />
        ## id nobs<br />
        ## 1  117<br />
        ## 2  1041<br />
        ## ...<br />
        ## where 'id' is the monitor ID number and 'nobs' is the<br />
        ## number of complete cases<br />
}
</pre>
<p>You can see some <a href="https://d396qusza40orc.cloudfront.net/rprog%2Fdoc%2Fcomplete-demo.html" rel="external nofollow noreferrer">example output from this function</a>. The function that you write should be able to match this output. Please save your code to a file named <strong>complete.R</strong>. To run the submit script for this part, make sure your working directory has the file <strong>complete.R</strong> in it.</p>
<div>
<pre class="prettyprint linenums">complete &lt;- function(directory, id = 1:332){<br />
    nobs &lt;- NULL<br />
    for(i in id){<br />
        fid &lt;- sprintf("%03d",i)<br />
        filename &lt;- paste(directory,"/",fid,".csv",sep="")<br />
        dat &lt;- read.csv(filename)<br />
        src &lt;- na.omit(dat)              # omit NA<br />
        nobs &lt;- c(nobs,dim(src)[1])<br />
    }<br />
    complete &lt;- data.frame(id,nobs)<br />
}
</pre>
</div>
<h3>Part 3</h3>
<p>Write a function that takes a directory of data files and a threshold for complete cases and calculates the correlation between sulfate and nitrate for monitor locations where the number of completely observed cases (on all variables) is greater than the threshold. The function should return a vector of correlations for the monitors that meet the threshold requirement. If no monitors meet the threshold requirement, then the function should return a numeric vector of length 0. A prototype of this function follows</p>
<pre class="prettyprint linenums">corr &lt;- function(directory, threshold = 0) {<br />
        ## 'directory' is a character vector of length 1 indicating<br />
        ## the location of the CSV files

        ## 'threshold' is a numeric vector of length 1 indicating the<br />
        ## number of completely observed observations (on all<br />
        ## variables) required to compute the correlation between<br />
        ## nitrate and sulfate; the default is 0

        ## Return a numeric vector of correlations<br />
        ## NOTE: Do not round the result!<br />
}
</pre>
<p>For this function you will need to use the 'cor' function in R which calculates the correlation between two vectors. Please read the help page for this function via '?cor' and make sure that you know how to use it.</p>
<p>You can see some <a href="https://d396qusza40orc.cloudfront.net/rprog%2Fdoc%2Fcorr-demo.html" rel="external nofollow noreferrer">example output from this function</a>. The function that you write should be able to match this output. Please save your code to a file named <strong>corr.R</strong>. To run the submit script for this part, make sure your working directory has the file <strong>corr.R</strong> in it.</p>
<div>
<pre class="prettyprint linenums">corr &lt;- function(directory, threshold = 0) {<br />
    corr.list &lt;- NULL<br />
    id &lt;- 1:332<br />
    dat &lt;- NULL<br />
    for(i in id){<br />
        fid &lt;- sprintf("%03d",i)<br />
        filename &lt;- paste(directory,"/",fid,".csv",sep="")<br />
        dat &lt;- read.csv(filename)<br />
        src &lt;- na.omit(dat)              # omit NA'<br />
        dat &lt;- src<br />
        len &lt;- length(dat$ID);<br />
        if(len &gt; threshold &amp;&amp; threshold &gt;=0 ){<br />
            corr.re &lt;- cor(dat$sulfate, dat$nitrate)<br />
            corr.list=c(corr.list, corr.re)<br />
        }<br />
    }<br />
    corr.list<br />
}
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8op51qz.html">前端学PHP之mysql扩展函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e1pzj9.html">Maven的环境搭建及新建web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/390jyyn8.html">通过数据库查看EBS的登录地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxj60j9.html">flex容器属性&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxzg09.html">BZOJ1579 &lbrack;Usaco2009 Feb&rsqb;Revamping Trails 道路升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ekw28.html">nginx php7 配置  备用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd17rr8.html">Blacksmith test</a>
		</li>
						<li><a href="https://www.batexi.com/a/95037wz8.html">图片翻转（Raw Image）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgv2w8.html">201521123023《Java程序设计》第10周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n46jq.html">Effective Java 第三版&mdash;&mdash;31&period;使用限定通配符来增加API的灵活性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy1d4n9.html">dp练习--</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7jd3q.html">Java虚拟机JVM相关知识整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25v0jxq.html">Elasticsearch5&period;5&period;1插件开发指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/95302km8.html">SliTaz  5&period;0 截图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2opjz8.html">C&num;通过XElement写入XML文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/902e774q.html">C&plus;&plus;&amp;amp&semi;C&num;外挂&lpar;内存修改&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/963lp7j9.html">springboot相关资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/963lyey9.html">Excel2010取消隐藏的工作簿</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnm1r4q.html">redis keys 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkz6d38.html">You need to use a Theme&period;AppCompat theme &lpar;or descendant&rpar; with this activity问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m96ggey8.html">CentOS彻底卸载wine</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4wwl59.html">帝国cms实现会员注册之后根据所在会员组转向的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mz7d0q.html">edmx代码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2vle38.html">JavaScriptCore框架介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn0zzg9.html">&lpar;翻译&rpar;如何对python dict 类型按键&lpar;keys&rpar;或值&lpar;values&rpar;排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn0xgj9.html">SVM支持向量机的高维映射与核函数-记录毕业论文2</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwxgxz9.html">c&num;&period;net WinForm 线程内 调用窗体控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvny6y9.html">kailli添加桌面快捷方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkw3e8.html">Win8&period;1微软官方最终正式版ISO镜像文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q73r0j8.html">easyUI学习笔记之tab组件的鼠标事件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
